<template>
  <v-app>
    <v-app-bar
      app
      :absolute="$vuetify.breakpoint.smAndDown"
      flat
      color="white"
      height="80"
    >
      <v-container fluid>
        <v-row>
          <v-col class="d-flex align-center">
            <router-link :to="isAdminPage ? '/admin' : '/'" class="d-flex align-center" style="text-decoration: none;">
              <div>
                <v-img
                  alt="Logo"
                  class="mr-3"
                  contain
                  src="./assets/img/logo.png"
                  transition="scale-transition"
                  width="60"
                  height="60"
                />
              </div>

              <h1
                id="logo-name"
                class="title font-weight-bold"
              >
                {{isAdminPage ? 'Панель администратора' : 'Национальные проекты Тюменской области'}}
              </h1>
            </router-link>

            <v-spacer/>

            <template v-if="!isAdminPage">
              <v-btn icon color="indigo" height="35" width="35">
                <v-img
                  alt="facebook-icon"
                  contain
                  width="20"
                  height="20"
                  src="./assets/img/fb-icon.png"
                />
              </v-btn>

              <v-btn icon color="indigo" height="35" width="35">
                <v-img
                  alt="instagram-icon"
                  contain
                  width="20"
                  height="20"
                  src="./assets/img/inst-icon.png"
                />
              </v-btn>
            </template>
            <v-btn v-else-if="status === 'success'" color="error" @click="logout">Выход</v-btn>
          </v-col>
        </v-row>
      </v-container>
    </v-app-bar>

    <v-container fluid class="pt-0">
      <v-row no-gutters>
        <v-col>
          <v-content>
            <router-view/>
          </v-content>
        </v-col>
      </v-row>
    </v-container>

    <v-footer id="footer" class="justify-center pt-5 pb-5" absolute>
      <h1 class="footer-text subtitle-1 font-weight-bold main-text-color text-center">
        Официальный интернет-портал национальных проектов Тюменской области 2020
      </h1>
    </v-footer>
  </v-app>
</template>

<script>
  import {loadYmap} from 'vue-yandex-maps';
  import {mapMutations} from 'vuex';
  import {apiInstance} from './api';
  import {mapState} from 'vuex';

  export default {
    name: 'App',

    components: {},
    methods: {
      ...mapMutations('search', [
        'setYmapsLoaded',
      ]),
      logout: async function() {
        await this.$store.dispatch('auth/logout');
        this.$router.push('/admin');
      },
    },
    computed: {
      isAdminPage: function() {
        return this.$route.meta.isAdminPage;
      },
      ...mapState('auth', [
        'status',
      ]),
    },
    async created() {
      apiInstance.interceptors.response.use(undefined, async (err) => {
        if (err.response.status === 401 && err.response.data.error.code !== 'LOGIN_FAILED') {
          await this.$store.dispatch('auth/logout');
          this.$router.push('/admin');
        } else {
          return Promise.reject(err);
        }
      });

      if (!this.isAdminPage) {
        this.$store.dispatch('categories/getCategories');
      }

      const settings = {
        apiKey: process.env.VUE_APP_YMAP_API,
      };

      await loadYmap({...settings, debug: true});
      this.setYmapsLoaded(true);
    },
  };
</script>

<style>
  #app {
    background-color: #F5F7FB;
  }

  #app .v-app-bar.v-app-bar--fixed {
    z-index: 1;
  }

  #logo-name {
    color: #44578c;
    line-height: 1.2rem;
  }

  .main-text-color {
    color: #556584;
  }

  .main-text-color-2 {
    color: #948585;
  }

  #footer {
    border-top: 1px solid #CCCACA;
    background-color: #F5F7FB;
    bottom: -70px !important;
    z-index: 0;
  }

  #search-card input {
    color: #556584;
  }

  #app .v-card__title {
    word-break: normal;
  }

  .v-select.v-select--is-menu-active .v-input__icon--append .v-icon {
    transform: rotate(0) !important;
  }

  @media screen and (max-width: 600px) {
    #logo-name {
      font-size: 1rem !important;
    }
  }
</style>
